/**
 * @license jquery.panzoom.js v1.3.8
 * Updated: Thu Jul 18 2013
 * Add pan and zoom functionality to any element
 * Copyright (c) 2013 timmy willison
 * Released under the MIT license
 * https://github.com/timmywil/jquery.panzoom/blob/master/MIT-License.txt
 */
(function(t,e){"function"==typeof define&&define.amd?define(["jquery"],e):e(t.jQuery)})(this,function(t){"use strict";var e={props:["touches","pageX","pageY"],filter:function(t,e){var n;return!e.pageX&&e.touches&&(n=e.touches[0])&&(t.pageX=n.pageX,t.pageY=n.pageY),t}};t.each(["touchstart","touchmove","touchend"],function(n,i){t.event.fixHooks[i]=e});var n="__pz__",i=Array.prototype.slice,a=/([A-Z])/g,s=/^http:[\w\.\/]+svg$/,o="(\\-?[\\d\\.e]+)",r="\\,?\\s*",h=RegExp("^matrix\\("+o+r+o+r+o+r+o+r+o+r+o+"\\)$"),c=function(e,i){1!==e.nodeType&&t.error("Panzoom called on non-Element node"),t.contains(document,e)||t.error("Panzoom element must be attached to the document");var o=t.data(e,n);if(o)return o;if(!(this instanceof c))return new c(e,i);this.options=i=t.extend({},c.defaults,i),this.elem=e;var r=this.$elem=t(e);this.$parent=r.parent(),this.isSVG=s.test(e.namespaceURI)&&"svg"!==e.nodeName.toLowerCase(),this.panning=!1,this._buildTransform(),this._transform=t.cssProps.transform.replace(a,"-$1").toLowerCase(),this._buildTransition(),this._buildContain();var h=t(),m=this;return t.each(["$zoomIn","$zoomOut","$zoomRange","$reset"],function(t,e){m[e]=i[e]||h}),this.enable(),t.data(e,n,this),this};return c.rmatrix=h,c.defaults={eventNamespace:".panzoom",transition:!0,cursor:"move",disablePan:!1,disableZoom:!1,increment:.3,minScale:.4,maxScale:5,duration:200,easing:"ease-in-out",contain:!1},c.prototype={constructor:c,instance:function(){return this},enable:function(){this._unbind(),this._initStyle(),this._bind(),this.disabled=!1},disable:function(){this.disabled=!0,this._resetStyle(),this._unbind()},isDisabled:function(){return this.disabled},destroy:function(){this.disable(),t.removeData(this.elem,n)},reset:function(t){var e=this.setMatrix(this._origTransform,{animate:"boolean"!=typeof t||t,range:!0});this._trigger("reset",e)},resetZoom:function(t){this._resetParts([0,3],t)},resetPan:function(t){this._resetParts([4,5],t)},getTransform:function(){var e=this.elem,n=t.style(e,"transform");return this.isSVG&&!n?n=t.attr(e,"transform"):"none"===n||h.test(n)||(n=t.style(e,"transform",t.css(e,"transform"))),n||"none"},getMatrix:function(t){var e=h.exec(t||this.getTransform());return e&&e.shift(),e||[1,0,0,1,0,0]},setMatrix:function(e,n){if(!this.disabled){n||(n={}),"string"==typeof e&&(e=this.getMatrix(e));var i,a,s,o,r,h=+e[0];return(i=n.contain!==void 0?n.contain:this.options.contain)&&(a="invert"===i,s=this.container,o=this.dimensions,r=(o.width*h-s.width)/2,e[4]=Math[a?"max":"min"](Math[a?"min":"max"](e[4],r-o.left),-r-o.left),r=(o.height*h-s.height)/2,e[5]=Math[a?"max":"min"](Math[a?"min":"max"](e[5],r-o.top),-r-o.top)),"skip"!==n.animate&&this.transition(!n.animate),n.range&&this.$zoomRange.val(h),t[this.isSVG?"attr":"style"](this.elem,"transform","matrix("+e.join(",")+")"),n.silent||this._trigger("change",e),e}},isPanning:function(){return this.panning},transition:function(e){var n=e||!this.options.transition?"none":this._transition;t.style(this.elem,"transition",n)},pan:function(t,e,n){n||(n={});var i=n.matrix;i||(i=this.getMatrix()),n.relative?(i[4]=+i[4]+t,i[5]=+i[5]+e):(i[4]=t,i[5]=e),this.setMatrix(i,n),n.silent||this._trigger("pan",t,e)},zoom:function(t,e){var n=!1,i=this.options;if(!i.disableZoom){"object"==typeof t?(e=t,t=null):e||(e={});var a=this.getMatrix(),s=e.middle;s&&(a[4]=+a[4]+(s.pageX===a[4]?0:s.pageX>a[4]?1:-1),a[5]=+a[5]+(s.pageY===a[5]?0:s.pageY>a[5]?1:-1)),"number"!=typeof t&&(t=+a[0]+i.increment*(t?-1:1),n=!0),t>i.maxScale?t=i.maxScale:i.minScale>t&&(t=i.minScale),a[0]=a[3]=t,this.setMatrix(a,{animate:"boolean"==typeof e.animate?e.animate:n,range:!e.noSetRange}),e.silent||this._trigger("zoom",t,e)}},option:function(e,n){var i;if(!e)return t.extend({},this.options);if("string"==typeof e){if(1===arguments.length)return this.options[e];i={},i[e]=n}else i=e;this._setOptions(i)},_setOptions:function(e){var n=this;t.each(e,function(e,i){switch(e){case"disablePan":n._resetStyle();case"disableZoom":case"$zoomIn":case"$zoomOut":case"$zoomRange":case"$reset":case"onStart":case"onChange":case"onZoom":case"onPan":case"onEnd":case"onReset":case"eventNamespace":n._unbind()}switch(n.options[e]=i,e){case"disablePan":n._initStyle();case"disableZoom":case"$zoomIn":case"$zoomOut":case"$zoomRange":case"$reset":case"onStart":case"onChange":case"onZoom":case"onPan":case"onEnd":case"onReset":case"eventNamespace":n._bind();break;case"cursor":t.style(n.elem,"cursor",i);break;case"minScale":n.$zoomRange.attr("min",i);break;case"maxScale":n.$zoomRange.attr("max",i);break;case"contain":n._buildContain();break;case"startTransform":n._buildTransform();break;case"duration":case"easing":n._buildTransition();case"transition":n.transition()}})},_initStyle:function(){this.options.disablePan||this.$elem.css("cursor",this.options.cursor);var e=this.$parent;if(e.length&&!t.nodeName(e[0],"body")){var n={overflow:"hidden"};"static"===e.css("position")&&(n.position="relative"),e.css(n)}},_resetStyle:function(){this.$elem.css({cursor:"",transition:""}),this.$parent.css({overflow:"",position:""})},_bind:function(){var e=this,n=this.options,i=n.eventNamespace,a="touchstart"+i+" mousedown"+i,s="touchend"+i+" click"+i,o={};if(t.each(["Start","Change","Zoom","Pan","End","Reset"],function(){var e=n["on"+this];t.isFunction(e)&&(o["panzoom"+this.toLowerCase()+i]=e)}),n.disablePan&&n.disableZoom||(o[a]=function(t){var i;("mousedown"===t.type?n.disablePan||1!==t.which:!(i=t.touches)||(1!==i.length||n.disablePan)&&2!==i.length)||(t.preventDefault(),t.stopPropagation(),e._startMove(t,i))}),this.$elem.on(o),!n.disableZoom){var r=this.$zoomIn,h=this.$zoomOut,c=this.$zoomRange,m=this.$reset;r.length&&h.length&&(r.on(s,function(t){t.preventDefault(),e.zoom()}),h.on(s,function(t){t.preventDefault(),e.zoom(!0)})),c.length&&(c.attr({min:n.minScale,max:n.maxScale,step:.05}).prop({value:this.getMatrix()[0]}),o={},o.mousedown=function(){e.transition(!0)},o["change"+i]=function(){e.zoom(+this.value,{noSetRange:!0})},c.on(o)),m.length&&m.on(s,function(t){t.preventDefault(),e.reset()})}},_unbind:function(){this.$elem.add(this.$zoomIn).add(this.$zoomOut).add(this.$reset).off(this.options.eventNamespace)},_buildTransform:function(){this._origTransform=this.options.startTransform||this.getTransform()},_buildTransition:function(){var t=this.options;this._transform&&(this._transition=this._transform+" "+t.duration+"ms "+t.easing)},_buildContain:function(){if(this.options.contain){var e=this.$parent;this.container={width:e.width(),height:e.height()};var n=this.elem,i=this.$elem;this.dimensions=this.isSVG?{left:n.getAttribute("x")||0,top:n.getAttribute("y")||0,width:n.getAttribute("width")||i.width(),height:n.getAttribute("height")||i.height()}:{left:t.css(n,"left",!0)||0,top:t.css(n,"top",!0)||0,width:i.width(),height:i.height()}}},_resetParts:function(t,e){for(var n=this.getMatrix(this._origTransform),i=this.getMatrix(),a=t.length;a--;)i[t[a]]=n[t[a]];this.setMatrix(i,{animate:"boolean"!=typeof e||e,range:!0})},_getDistance:function(t){var e=t[0],n=t[1];return Math.sqrt(Math.pow(Math.abs(n.pageX-e.pageX),2)+Math.pow(Math.abs(n.pageY-e.pageY),2))},_getMiddle:function(t){var e=t[0],n=t[1];return{pageX:(n.pageX-e.pageX)/2+e.pageX,pageY:(n.pageY-e.pageY)/2+e.pageY}},_trigger:function(t){this.$elem.triggerHandler("panzoom"+t,[this].concat(i.call(arguments,1)))},_startMove:function(e,n){var i,a,s,o,r,h,c=this,m=this.options,u="touchstart"===e.type,g=m.eventNamespace,l=(u?"touchmove":"mousemove")+g,p=(u?"touchend":"mouseup")+g,f=this.getMatrix(),d={matrix:f,animate:"skip"},v=f.slice(0),b=+v[4],_=+v[5];this.transition(!0),this.panning=!0,this._trigger("start",e,n),n&&2===n.length?(a=this._getDistance(n),s=+f[0],o=this._getMiddle(n),i=function(t){t.preventDefault();var e=c._getMiddle(n=t.touches);c.pan(b+e.pageX-o.pageX,_+e.pageY-o.pageY,d);var i=c._getDistance(n)-a;c.zoom(i/300+s,{middle:e})}):(r=e.pageX,h=e.pageY,i=function(t){t.preventDefault(),c.pan(b+t.pageX-r,_+t.pageY-h,d)}),t(document).off(g).on(l,i).on(p,function(e){e.preventDefault(),t(this).off(g),c.panning=!1,c._trigger("end",f,!!t(v).not(f).length)})}},t.fn.panzoom=function(e){var a,s,o,r;return"string"==typeof e?(r=[],s=i.call(arguments,1),this.each(function(){a=t.data(this,n),a?"_"!==e.charAt(0)&&"function"==typeof(o=a[e])&&void 0!==(o=o.apply(a,s))&&r.push(o):r.push(void 0)}),r.length?1===r.length?r[0]:r:this):this.each(function(){new c(this,e)})},c});